#ifndef _KGR_PATCH_BSC1179616_H
#define _KGR_PATCH_BSC1179616_H

#if IS_ENABLED(CONFIG_SND_RAWMIDI)

int kgr_patch_bsc1179616_init(void);
void kgr_patch_bsc1179616_cleanup(void);


struct snd_rawmidi_substream;
struct snd_rawmidi_params;
struct file;

int kgrp_snd_rawmidi_output_params(struct snd_rawmidi_substream *substream,
			      struct snd_rawmidi_params *params);
int kgrp_snd_rawmidi_input_params(struct snd_rawmidi_substream *substream,
			     struct snd_rawmidi_params *params);
long kgrp_snd_rawmidi_kernel_read(struct snd_rawmidi_substream *substream,
			     unsigned char *buf, long count);
 ssize_t kgrp_snd_rawmidi_read(struct file *file, char __user *buf, size_t count,
				loff_t *offset);
long kgrp_snd_rawmidi_kernel_write1(struct snd_rawmidi_substream *substream,
				      const unsigned char __user *userbuf,
				      const unsigned char *kernelbuf,
				      long count);

#define KGR_PATCH_BSC1179616_FUNCS					\
	KGR_PATCH_OBJ(snd_rawmidi_output_params,			\
		      kgrp_snd_rawmidi_output_params, "snd_rawmidi"),	\
	KGR_PATCH_OBJ(snd_rawmidi_input_params,			\
		      kgrp_snd_rawmidi_input_params, "snd_rawmidi"),	\
	KGR_PATCH_OBJ(snd_rawmidi_kernel_read,				\
		      kgrp_snd_rawmidi_kernel_read, "snd_rawmidi"),	\
	KGR_PATCH_OBJ(snd_rawmidi_read,				\
		      kgrp_snd_rawmidi_read, "snd_rawmidi"),		\
	KGR_PATCH_OBJ(snd_rawmidi_kernel_write1,			\
		      kgrp_snd_rawmidi_kernel_write1, "snd_rawmidi"),	\

#else /* !IS_ENABLED(CONFIG_SND_RAWMIDI) */

static inline int kgr_patch_bsc1179616_init(void) { return 0; }

static inline void kgr_patch_bsc1179616_cleanup(void) {}

#define KGR_PATCH_BSC1179616_FUNCS

#endif /* IS_ENABLED(CONFIG_SND_RAWMIDI) */
#endif /* _KGR_PATCH_BSC1179616_H */
